/********Stata code used for the TN:Extending WID Population Series:
Projections 2024-2100 & Age/Gender Breakdowns*********/

/****Creates graphs for analyzing origin and destination of migrants at the
reginal level**/




**# WID regions (country level)
*Import data on regions 
import excel using "$root\raw-data\country_subregions_codes_.xlsx",clear firstrow
ren WIDcode country
keep country countryname
	loc s countryname
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)	
			replace `s' = subinstr(`s', "'", "", .)		
			replace `s' = subinstr(`s', "Coted'Ivoire", "CotedIvoire", .)					
save "$work_data\temp_country_countryname.dta",replace 


import excel "$root\raw-data/undesa_pd_2020_ims_stock_by_sex_destination_and_origin.xlsx", ///
	sheet("Table 1") cellrange(A11) firstrow case(lower) clear	
	
	
		ren regiondevelopmentgroupcount destination
	ren f origin
	ren h all_1990
	ren i all_1995
	ren j all_2000
	ren k all_2005
	ren l all_2010	
	ren m all_2015		
	ren n all_2020
	
keep destination origin all*	

*Origin
ren origin countryname
	loc s countryname
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', "*", "", .)			
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', "Bolivia(PlurinationalStateof)", "Bolivia", .)			
			replace `s' = subinstr(`s', "Bonaire,SintEustatiusandSaba", "Bonaire", .)
			replace `s' = subinstr(`s', "BritishVirginIslands", "Virgin Islands, British", .)
			replace `s' = subinstr(`s', "China,HongKongSAR", "Hong Kong", .)		
			replace `s' = subinstr(`s', "China,MacaoSAR", "Macao", .)		
			replace `s' = subinstr(`s', "China,TaiwanProvinceofChina", "Taiwan", .)		
			replace `s' = subinstr(`s', "Curaçao", "Curacao", .)		
			replace `s' = subinstr(`s', "Czechia", "Czech Republic", .)		
			replace `s' = subinstr(`s', "Côted'Ivoire", "Cote d'Ivoire", .)		
			replace `s' = subinstr(`s', "Dem.People'sRepublicofKorea", "North Korea", .)		
			replace `s' = subinstr(`s', "DemocraticRepublicoftheCongo", "DR Congo", .)
			replace `s' = subinstr(`s', "Eswatini", "Swaziland", .)
			replace `s' = subinstr(`s', "FalklandIslands(Malvinas)", "Falkland Islands", .)
			replace `s' = subinstr(`s', "Iran(IslamicRepublicof)", "Iran", .)
			replace `s' = subinstr(`s', "LaoPeople'sDemocraticRepublic", "Lao PDR", .)
			replace `s' = subinstr(`s', "Micronesia(Fed.Statesof)", "Micronesia", .)
			replace `s' = subinstr(`s', "RepublicofKorea", "Korea", .)
			replace `s' = subinstr(`s', "RepublicofMoldova", "Moldova", .)
			replace `s' = subinstr(`s', "StateofPalestine", "Palestine", .)
			replace `s' = subinstr(`s', "UnitedRepublicofTanzania", "Tanzania", .)		
			replace `s' = subinstr(`s', "UnitedStatesVirginIslands", "Virgin Islands, US", .)	
			replace `s' = subinstr(`s', "UnitedStatesofAmerica", "USA", .)					
			replace `s' = subinstr(`s', "Venezuela(BolivarianRepublicof)", "Venezuela", .)	
			replace `s' = subinstr(`s', "WallisandFutunaIslands", "Wallis and Futuna", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', "*", "", .)			
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', "'", "", .)		
			replace `s' = subinstr(`s', "CotedIvoire", "CotedIvoire", .)				

			
			
			
drop if inlist(countryname,"Eastern Africa","Middle Africa","NorthernAfrica","SouthernAfrica","WesternAfrica","CentralAsia","EasternAsia") ///
|inlist(countryname,"South-EasternAsia","SouthernAsia","WesternAsia","EUROPE")| ///
inlist(countryname,"LATINAMERICAANDTHECARIBBEAN","OCEANIA","NORTHERNAMERICA")	| ///
inlist(countryname,"ASIA","AFRICA","AustraliaandNewZealand","CentralAmerica","Caribbean","CentralandSouthernAsia","Developedregions")		| ///
inlist(countryname,	"EasternAfrica", "EasternEurope","EasternandSouth-EasternAsia","EuropeandNorthernAmerica","High-incomecountries", "Land-lockedDevelopingCountries(LLDC)")		| ///
inlist(countryname, "LatinAmericaandtheCaribbean", "Leastdevelopedcountries","Lessdevelopedregions", "Lessdevelopedregions,excludingChina","Low-incomecountries","Lower-middle-incomecountries")		| ///
inlist(countryname, "Middle-incomecountries", "MiddleAfrica","NorthernAfricaandWesternAsia","NorthernEurope","Lessdevelopedregions,excludingleastdevelopedcountries") 		| ///
inlist(countryname,"Oceania(excludingAustraliaandNewZealand)", "Other",  "SmallislanddevelopingStates(SIDS)", "SouthAmerica","SouthernEurope","Sub-SaharanAfrica","Upper-middle-incomecountries" ) 		| ///
inlist(countryname, "WORLD", "WesternEurope","Melanesia","Polynesia")

merge m:1 countryname using "$work_data\temp_country_countryname.dta"

*France
replace country="GF" if countryname=="FrenchGuiana"
replace country="GP" if countryname=="Guadeloupe"
replace country="MQ" if countryname=="Martinique" 
replace country="YT" if countryname=="Mayotte" 
replace country="RE" if countryname=="Réunion" 
replace country="BL" if countryname=="SaintBarthélemy" 
replace country="SF" if countryname=="SaintMartin(Frenchpart)" 

replace country="FR" if country=="GF" //French Guiana
replace country="FR" if country=="GP" //Guadeloupe
replace country="FR" if country=="MQ" //Martinique
replace country="FR" if country=="YT"
replace country="FR" if country=="RE" //Reunion
replace country="FR" if country=="BL" //Saint Barthélemy
replace country="FR" if country=="SF"

*CotedIvoire
replace country="CI" if countryname=="CotedIvoire"
tab countryname if country==""


drop if country==""
tab _merge
drop _merge

ren country country_origin
drop countryname




*Destination
*Origin
ren destination countryname
	loc s countryname
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', "*", "", .)			
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', "Bolivia(PlurinationalStateof)", "Bolivia", .)			
			replace `s' = subinstr(`s', "Bonaire,SintEustatiusandSaba", "Bonaire", .)
			replace `s' = subinstr(`s', "BritishVirginIslands", "Virgin Islands, British", .)
			replace `s' = subinstr(`s', "China,HongKongSAR", "Hong Kong", .)		
			replace `s' = subinstr(`s', "China,MacaoSAR", "Macao", .)		
			replace `s' = subinstr(`s', "China,TaiwanProvinceofChina", "Taiwan", .)		
			replace `s' = subinstr(`s', "Curaçao", "Curacao", .)		
			replace `s' = subinstr(`s', "Czechia", "Czech Republic", .)		
			replace `s' = subinstr(`s', "Côted'Ivoire", "Cote d'Ivoire", .)		
			replace `s' = subinstr(`s', "Dem.People'sRepublicofKorea", "North Korea", .)		
			replace `s' = subinstr(`s', "DemocraticRepublicoftheCongo", "DR Congo", .)
			replace `s' = subinstr(`s', "Eswatini", "Swaziland", .)
			replace `s' = subinstr(`s', "FalklandIslands(Malvinas)", "Falkland Islands", .)
			replace `s' = subinstr(`s', "Iran(IslamicRepublicof)", "Iran", .)
			replace `s' = subinstr(`s', "LaoPeople'sDemocraticRepublic", "Lao PDR", .)
			replace `s' = subinstr(`s', "Micronesia(Fed.Statesof)", "Micronesia", .)
			replace `s' = subinstr(`s', "RepublicofKorea", "Korea", .)
			replace `s' = subinstr(`s', "RepublicofMoldova", "Moldova", .)
			replace `s' = subinstr(`s', "StateofPalestine", "Palestine", .)
			replace `s' = subinstr(`s', "UnitedRepublicofTanzania", "Tanzania", .)		
			replace `s' = subinstr(`s', "UnitedStatesVirginIslands", "Virgin Islands, US", .)	
			replace `s' = subinstr(`s', "UnitedStatesofAmerica", "USA", .)					
			replace `s' = subinstr(`s', "Venezuela(BolivarianRepublicof)", "Venezuela", .)	
			replace `s' = subinstr(`s', "WallisandFutunaIslands", "Wallis and Futuna", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', "*", "", .)			
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', "'", "", .)		
			replace `s' = subinstr(`s', "CotedIvoire", "CotedIvoire", .)				

			
			
			
drop if inlist(countryname,"Eastern Africa","Middle Africa","NorthernAfrica","SouthernAfrica","WesternAfrica","CentralAsia","EasternAsia") ///
|inlist(countryname,"South-EasternAsia","SouthernAsia","WesternAsia","EUROPE")| ///
inlist(countryname,"LATINAMERICAANDTHECARIBBEAN","OCEANIA","NORTHERNAMERICA")	| ///
inlist(countryname,"ASIA","AFRICA","AustraliaandNewZealand","CentralAmerica","Caribbean","CentralandSouthernAsia","Developedregions")		| ///
inlist(countryname,	"EasternAfrica", "EasternEurope","EasternandSouth-EasternAsia","EuropeandNorthernAmerica","High-incomecountries", "Land-lockedDevelopingCountries(LLDC)")		| ///
inlist(countryname, "LatinAmericaandtheCaribbean", "Leastdevelopedcountries","Lessdevelopedregions", "Lessdevelopedregions,excludingChina","Low-incomecountries","Lower-middle-incomecountries")		| ///
inlist(countryname, "Middle-incomecountries", "MiddleAfrica","NorthernAfricaandWesternAsia","NorthernEurope","Lessdevelopedregions,excludingleastdevelopedcountries") 		| ///
inlist(countryname,"Oceania(excludingAustraliaandNewZealand)", "Other",  "SmallislanddevelopingStates(SIDS)", "SouthAmerica","SouthernEurope","Sub-SaharanAfrica","Upper-middle-incomecountries" ) 		| ///
inlist(countryname, "WORLD", "WesternEurope","Melanesia","Polynesia")

merge m:1 countryname using "$work_data\temp_country_countryname.dta"

*France
replace country="GF" if countryname=="FrenchGuiana"
replace country="GP" if countryname=="Guadeloupe"
replace country="MQ" if countryname=="Martinique" 
replace country="YT" if countryname=="Mayotte" 
replace country="RE" if countryname=="Réunion" 
replace country="BL" if countryname=="SaintBarthélemy" 
replace country="SF" if countryname=="SaintMartin(Frenchpart)" 

replace country="FR" if country=="GF"
replace country="FR" if country=="GP"
replace country="FR" if country=="MQ"
replace country="FR" if country=="YT"
replace country="FR" if country=="RE"
replace country="FR" if country=="BL"
replace country="FR" if country=="SF"

*CotedIvoire
replace country="CI" if countryname=="CotedIvoire"
tab countryname if country==""


drop if country==""
tab _merge

drop if all_1990==. & all_1995==. & all_2000==. & all_2005==. & all_2010==. & all_2015==. & all_2020==.
drop _merge

ren country country_destination
drop countryname

*Collapse for France
collapse (sum) all_1990 all_1995 all_2000 all_2005 all_2010 all_2015 all_2020, by(country_origin country_destination)

*Drop if migrated from France to France or Micronesia to Micronesia
drop if  country_origin ==country_destination

*keep only 216 countries
 *Keep core countries
gen corecountry_origin=.
foreach c of global corecountries {
	replace corecountry_origin=1 if country_origin=="`c'"
	}
gen corecountry_destination=.
foreach c of global corecountries {
	replace corecountry_destination=1 if country_destination=="`c'"
	}	
keep if (corecountry_destination==1 & corecountry_origin==1)	


*Generate Region variable
 gen region2=""
foreach c of global EURO {
	replace region2="EURO" if country_origin=="`c'"
	}
foreach c of global NAOC {
	replace region2="NAOC" if country_origin=="`c'"
	}
foreach c of global LATA {
	replace region2="LATA" if country_origin=="`c'"
	}
foreach c of global MENA {
	replace region2="MENA" if country_origin=="`c'"
	}
foreach c of global SSAF {
	replace region2="SSAF" if country_origin=="`c'"
	}
foreach c of global RUCA {
	replace region2="RUCA" if country_origin=="`c'"
	}
foreach c of global EASA {
	replace region2="EASA" if country_origin=="`c'"
	}	
foreach c of global SSEA {
	replace region2="SSEA" if country_origin=="`c'"
	}		
ren region2 region_origin

 gen region2=""
foreach c of global EURO {
	replace region2="EURO" if country_destination=="`c'"
	}
foreach c of global NAOC {
	replace region2="NAOC" if country_destination=="`c'"
	}
foreach c of global LATA {
	replace region2="LATA" if country_destination=="`c'"
	}
foreach c of global MENA {
	replace region2="MENA" if country_destination=="`c'"
	}
foreach c of global SSAF {
	replace region2="SSAF" if country_destination=="`c'"
	}
foreach c of global RUCA {
	replace region2="RUCA" if country_destination=="`c'"
	}
foreach c of global EASA {
	replace region2="EASA" if country_destination=="`c'"
	}	
foreach c of global SSEA {
	replace region2="SSEA" if country_destination=="`c'"
	}		
ren region2 region_destination

drop corecountry_origin corecountry_destination

save "$outputs\migration_matrix_216countries_1990_2020.dta",replace 


**# WID regions (region level)

use "$outputs\migration_matrix_216countries_1990_2020.dta",clear
collapse (sum) all* , by(region_origin region_destination)
foreach var in all_1990 all_1995 all_2000 all_2005 all_2010 all_2015 all_2020{
	replace `var'=`var'/1000000
	replace `var'=0 if region_origin==region_destination
}
order region_destination region_origin all_1990 all_1995 all_2000 all_2005 all_2010 all_2015 all_2020
sort region_destination

replace region_destination="Europe" if region_destination=="EURO"
replace region_destination="East Asia" if region_destination=="EASA"
replace region_destination="Middle East/North Africa" if region_destination=="MENA"
replace region_destination="Russia/Central Asia" if region_destination=="RUCA"
replace region_destination="Latin America" if region_destination=="LATA"
replace region_destination="North America/Oceania" if region_destination=="NAOC"
replace region_destination="Subsaharan Africa" if region_destination=="SSAF"
replace region_destination="South & South-East Asia" if region_destination=="SSEA"

replace region_origin="Europe" if region_origin=="EURO"
replace region_origin="East Asia" if region_origin=="EASA"
replace region_origin="Middle East/North Africa" if region_origin=="MENA"
replace region_origin="Russia/Central Asia" if region_origin=="RUCA"
replace region_origin="Latin America" if region_origin=="LATA"
replace region_origin="North America/Oceania" if region_origin=="NAOC"
replace region_origin="Subsaharan Africa" if region_origin=="SSAF"
replace region_origin="South & South-East Asia" if region_origin=="SSEA"


sort region_destination region_origin
export excel using $outputs/GomezCarreraetal2024Pop.xlsx, sheet("Data_F11", modify) cell(B5) keepcellfmt