/********Stata code used for the TN:Extending WID Population Series:
Projections 2024-2100 & Age/Gender Breakdowns*********/

/****Re do populations using Federico-Tena's 1800-1938 series (better) **/


**# WID regions (country level)
*Import data on regions 
import excel using "$root\raw-data\country_subregions_codes_.xlsx",clear firstrow
ren WIDcode country
keep country countryname
	loc s countryname
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)	
			replace `s' = subinstr(`s', "'", "", .)		
			replace `s' = subinstr(`s', "Coted'Ivoire", "CotedIvoire", .)					
save "$work_data\temp_country_countryname.dta",replace 

use "$work_data\pop_1800_2100_57extendedterritories.dta",clear
reshape wide pop999i , i(year) j(country) string


**# Load Federico-Tena World Population Historical Database : Europe
import excel using "$root\raw-data\europe_1800-1938_FTWPHD_2023_v01.xlsx",clear firstrow
drop if inlist(EUROPE,"Population (000)","","World Country Nº ")
ren EUROPE year
destring year, replace
foreach country in Albania Andorra Austria AustriaHungary Belgium Bulgaria CreteAegeanIslands CyprusAegeanIslands Czechoslovakia Denmark DodecaneseIsAegeanIslands Estonia Finland France Germany Gibraltar Greece Hungary Iceland Ionianislands Ireland Italy Latvia Lithuania Luxembourg Malta Monaco Montenegro Netherlands Norway OttomanBalkans Poland Portugal Romania RussiaEmpireUSSR SerbiaYugoslavia Spain Sweden Switzerland UnitedKingdom EUROPA{
	ren `country' pop`country'
}
reshape long pop, i(year) j(countryname) string
	loc s countryname
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)	
			replace `s' = subinstr(`s', "'", "", .)		
			replace `s' = subinstr(`s', "Coted'Ivoire", "CotedIvoire", .)
save "$work_data\FT_europe.dta",replace 

**# Load Federico-Tena World Population Historical Database : Asia
import excel using "$root\raw-data\asia_1800-1938_FTWPHD_2023_v01.xlsx",clear firstrow
drop if inlist(ASIA,"Population (000)","","World Country Nº ")
ren ASIA year
destring year, replace
foreach country in AdenandSocotra Afghanistan ArabianPeninsulaOttomanEmpir BahrainOttomanEmpire Bhutan BritishMalaya BritishNorthBorneo Brunei Ceylon China DutchEastIndiesIndonesia EastTimor FrenchIndia FrenchIndochina HongKong India IraqOttomanEmpire Japan KhivaandBukharaRussianEmpir Korea KuwaitOttomanEmpire Macau MaldiveIndia Mongolia Nepal NorthYemenOttomanEmpire OmanOttomanEmpire OttomanEmpireAsiaTurkey PalestineOttomanEmpire PersiaIran Philippines PortugueseIndia QatarOttomanEmpire Sarawak Siam SyriaandLebanonOttomanEmpir UnitedArabEmiratesOttomanEm AM{
	ren `country' pop`country'
}
destring pop* , replace
reshape long pop, i(year) j(countryname) string
	loc s countryname
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)	
			replace `s' = subinstr(`s', "'", "", .)		
			replace `s' = subinstr(`s', "Coted'Ivoire", "CotedIvoire", .)
save "$work_data\FT_asia.dta",replace 		


**# Load Federico-Tena World Population Historical Database : Africa
import excel using "$root\raw-data\africa_1800-1938_FTWPHD_2023_v01.xlsx",clear cellrange(A2) firstrow
ren A AFRICA_
drop if inlist(AFRICA_,"Population (000)","","World Country Nº ")
ren AFRICA_ year
destring year, replace
foreach country in Algeria Angola Basutoland Bechuanaland BelgiumCongo BritishEastAfrica CapeVerdePortugueseAfrica Cameroon CeutayMelilla ComorosandMayoteFrench Egypt EquatorialGuinea Eritrea Ethiopia FrenchEquatorialAfricaCongoF FrenchSomalia FrenchWestAfrica Gambia GermanEastAfrica GermanSouthWestAfrica GermanWestAfrica GhanaGoldCoast GuineaBissauPortugueseAfrica ItalianLibiaCyrenaica ItalianSomaliland Liberia Madagascar Malawi Mauritius Morocco MozambiquePortugueseAfrica Nigeria NorthernRhodesia Réunion RwandaandBurundi StHelena SaoTomeandPrincipePortugues Seychelles SierraLeone SouthAfrica SouthernRhodesia SpanishSahara SudanAngloEgyptianSudan Swaziland Tunisia ZanzibarIsland AFRICA{
	ren `country' pop`country'
}
destring pop* , replace
reshape long pop, i(year) j(countryname) string
	loc s countryname
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)	
			replace `s' = subinstr(`s', "'", "", .)		
			replace `s' = subinstr(`s', "Coted'Ivoire", "CotedIvoire", .)
save "$work_data\FT_africa.dta",replace 			



**# Load Federico-Tena World Population Historical Database : America
import excel using "$root\raw-data\america_1800-1938_FTWPHD_2024_v01.xlsx",clear cellrange(A2) firstrow
ren A AMERICA_
drop if inlist(AMERICA_,"Population (000)","","World Country Nº ")
ren AMERICA_ year
destring year, replace
foreach country in Argentina Bahamas Barbados Bermuda Bolivia Brazil BritishGuiana BritishHondurasBelize Canada CaymanIsland Chile Colombia CostaRica Cuba DanishVirginIslands DominicanRepublic DutchWestIndiesNetherlandsA Ecuador ElSalvador FalklandIslands FrenchGuianaFrenchColonies GrenadaWindwardIslands GuadeloupeFrenchColonies Guatemala Haiti Honduras Jamaica LeewardIslandsAnguillaLIA MartiniqueFrenchColonies Mexico Newfoundland Nicaragua Panama Paraguay Peru PuertoRico SaintBarthélemyNorwegiancolo SaintLuciaWindwardIslands SaintPierreandMiquelon SaintVincentWindwardIslands SurinameDutchGuiana TrinidadandTobagoWindwardIs TurksandCaicosIslands UnitedStates Uruguay Venezuela TOTAL AW AX{
	ren `country' pop`country'
}
reshape long pop, i(year) j(countryname) string
	loc s countryname
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)	
			replace `s' = subinstr(`s', "'", "", .)		
			replace `s' = subinstr(`s', "Coted'Ivoire", "CotedIvoire", .)
save "$work_data\FT_america.dta",replace 

**# Load Federico-Tena World Population Historical Database : Oceania
import excel using "$root\raw-data\oceania_1800-1938_FTWPHD_2023_v01.xlsx",clear cellrange(A1) firstrow
drop if inlist(OCEANIA,"Population (000)","","World Country Nº ")
ren OCEANIA year		
destring year TOTAL, replace
foreach country in Australia Hawaii NewZealand Melanesia Micronesia Polynesia TOTAL{
	ren `country' pop`country'
}
reshape long pop, i(year) j(countryname) string
	loc s countryname
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)
			replace `s' = subinstr(`s', " ", "", .)	
			replace `s' = subinstr(`s', "'", "", .)		
			replace `s' = subinstr(`s', "Coted'Ivoire", "CotedIvoire", .)
save "$work_data\FT_oceania.dta",replace 



**# Load the manually generated using FT IHS and UN data
import excel using "$root\raw-data\FT_UN_IHS.xlsx",clear firstrow sheet("FT_UN_IHS")
ren A year
save "$work_data\FT_UN_IHS.dta",replace














**# ALL

	use "$work_data\FT_africa.dta",clear
	append using "$work_data\FT_asia.dta"
	append using "$work_data\FT_america.dta"
	replace countryname="AMERICAS" if countryname=="TOTAL"
	append using "$work_data\FT_europe.dta"
	append using "$work_data\FT_oceania.dta"
	replace countryname="OCEANIA" if countryname=="TOTAL"

replace countryname="ASIA" if countryname=="AM"
replace countryname="Korea total" if countryname=="Korea"	
replace countryname="BritishIndia" if countryname=="India"
replace countryname="China and Taiwan" if countryname=="China"	
drop if countryname=="AX" | countryname=="AW" 


replace countryname="EUROPE" if countryname=="EUROPA"		

merge m:1 countryname using "$work_data\temp_country_countryname.dta"	

replace country="AFRICA" if countryname=="AFRICA"
replace country="LS" if countryname=="Basutoland" //Lesotho
replace country="BW" if countryname=="Bechuanaland" //Botswana
replace country="CD" if countryname=="BelgiumCongo" //DR Congo
replace country="CV" if countryname=="CapeVerdePortugueseAfrica" //Cabo Verde
replace country="KM" if countryname=="ComorosandMayoteFrench" // 	Comoros
replace country="CG" if countryname=="FrenchEquatorialAfricaCongoF" //Congo
replace country="DJ" if countryname=="FrenchSomalia" //Djibouti
replace country="TZ" if countryname=="GermanEastAfrica" //Tanzania
replace country="NA" if countryname=="GermanSouthWestAfrica" //Namibia
replace country="TG" if countryname=="GermanWestAfrica" //Togo 
replace country="GH" if countryname=="GhanaGoldCoast" //Ghana
replace country="GW" if countryname=="GuineaBissauPortugueseAfrica" //Guinea-Bissau
replace country="LY" if countryname=="ItalianLibiaCyrenaica" //	Libya
replace country="SO" if countryname=="ItalianSomaliland" //	Somalia
replace country="MZ" if countryname=="MozambiquePortugueseAfrica" //	Mozambique
replace country="ZM" if countryname=="NorthernRhodesia" //	Zambia
replace country="RE" if countryname=="Réunion" //	Réunion-FRance
replace country="ST" if countryname=="SaoTomeandPrincipePortugues" //	Sao Tome and Principe
replace country="ZW" if countryname=="SouthernRhodesia" //Zimbabwe 
replace country="SH" if countryname=="StHelena" //Saint Helena 
replace country="ZZ" if countryname=="ZanzibarIsland" //Zanzibar 
replace country="FrenchWestAfrica" if countryname=="FrenchWestAfrica" //FrenchWestAfrica
replace country="BritishEastAfrica" if countryname=="BritishEastAfrica" // BritishEastAfrica"
replace country="RwandaandBurundi" if countryname=="RwandaandBurundi" // RwandaandBurundi"
replace country="SudanAngloEgyptianSudan" if countryname=="SudanAngloEgyptianSudan" // SudanAngloEgyptianSudan"

replace country="ASIA" if countryname=="ASIA"
replace country="SA" if countryname=="ArabianPeninsulaOttomanEmpir" //	Saudi Arabia
replace country="BH" if countryname=="BahrainOttomanEmpire" //	Bahrain
replace country="BN" if countryname=="Brunei" //	Brunei
replace country="LK" if countryname=="Ceylon" //	Sri Lanka
replace country="ID" if countryname=="DutchEastIndiesIndonesia" //	Indonesia
replace country="TL" if countryname=="EastTimor" //		Timor-Leste
replace country="IQ" if countryname=="IraqOttomanEmpire" //			Iraq
replace country="UZ" if countryname=="KhivaandBukharaRussianEmpir" //			Uzbekistan
replace country="KW" if countryname=="KuwaitOttomanEmpire" //Kuwait
replace country="MO" if countryname=="Macau" //Macao
replace country="MV" if countryname=="MaldiveIndia" //Maldives
replace country="YE" if countryname=="NorthYemenOttomanEmpire" //Yemen
replace country="OM" if countryname=="OmanOttomanEmpire" //Oman
replace country="TR" if countryname=="OttomanEmpireAsiaTurkey" //Turkey
replace country="PS" if countryname=="PalestineOttomanEmpire" //Palestine
replace country="IR" if countryname=="PersiaIran" //Iran
replace country="QA" if countryname=="QatarOttomanEmpire" //Qatar
replace country="TH" if countryname=="Siam" //	Thailand
replace country="AE" if countryname=="UnitedArabEmiratesOttomanEm" //		United Arab Emirates


replace country="AMERICA" if countryname=="AMERICAS"
replace country="GY" if countryname=="BritishGuiana" //	Guyana
replace country="KY" if countryname=="CaymanIsland" //	Cayman Islands
replace country="VI" if countryname=="DanishVirginIslands" //	Virgin Islands, US
replace country="GF" if countryname=="FrenchGuianaFrenchColonies" //	FrenchGuiana France
replace country="GD" if countryname=="GrenadaWindwardIslands" //	Grenada
replace country="GP" if countryname=="GuadeloupeFrenchColonies" //	Guadeloupe France
replace country="MQ" if countryname=="MartiniqueFrenchColonies" //	Martinique France
replace country="BL" if countryname=="SaintBarthélemyNorwegiancolo" //	Saint Barthélemy (Norwegian colonies)
replace country="LC" if countryname=="SaintLuciaWindwardIslands" //	Saint Lucia
replace country="VC" if countryname=="SaintVincentWindwardIslands" //	Saint Vincent and the Grenadines
replace country="SR" if countryname=="SurinameDutchGuiana" //	Suriname
replace country="TT" if countryname=="TrinidadandTobagoWindwardIs" //	Trinidad and Tobago
replace country="US" if countryname=="UnitedStates" //	United States

replace country="CA_NF" if countryname=="Newfoundland" //	Newfoundland

replace country="OCEANIA" if countryname=="OCEANIA"

replace country="EUROPE" if countryname=="EUROPE"
replace country="US_HI" if countryname=="Hawaii" //	Hawaii
replace country="OttomanBalkans" if countryname=="OttomanBalkans" //	Ottoman Balkans
replace country="SerbiaYugoslavia" if countryname=="SerbiaYugoslavia" //	SerbiaYugoslavia
replace country="AustriaHungary" if countryname=="AustriaHungary" //	AustriaHungary
replace country="CY" if countryname=="CyprusAegeanIslands" //	Cyprus
replace country="CS" if countryname=="Czechoslovakia" //	Czechoslovakia
replace country="RussiaEmpireUSSR" if countryname=="RussiaEmpireUSSR" //	RussiaEmpireUSSR



keep if country!=""
keep year country pop

replace pop=pop*1000
ren pop pop999i
append using "$outputs\widpop_1950_2100_216countries.dta"

keep year country pop999i
keep if year<2024

sort year
// g variable="pop"
duplicates report year country
duplicates tag year country, g(tag)
tab country if tag>0
drop tag

reshape wide pop999i, i(year) j(country) string
insobs 11
egen seq=seq()
replace seq=seq+1725
replace year=seq if year==.
drop seq
sort year

ren pop999i* *

tsset year
foreach var in AD AE AF AFRICA AG AI AL AM AMERICA AO AR ASIA AT AU AW AZ AustriaHungary BA BB BD BE BF BG BH BI BJ BL BM BN BO BQ BR BS BT BW BY BZ CA CA_NF CD CF CG CH CI CL CM CN CO CR CS CU CV CW CY CZ DE DJ DK DM DO DZ EC EE EG ER ES ET EUROPE FI FJ FK FM FR GA GB GD GE GF GG GH GI GL GM GN GP GQ GR GT GW GY HK HN HR HT HU ID IE IL IM IN IQ IR IS IT JE JM JO JP KE KG KH KI KM KN KP KR KS KW KY KZ LA LB LC LI LK LR LS LT LU LV LY MA MC MD ME MG MH MK ML MM MN MO MQ MR MS MT MU MV MW MX MY MZ NA NC NE NG NI NL NO NP NR NZ OCEANIA OM OttomanBalkans PA PE PF PG PH PK PL PM PR PS PT PW PY QA RE RO RS RU RW RussiaEmpireUSSR SA SB SC SD SE SG SH SI SK SL SM SN SO SR SS ST SV SX SY SZ SerbiaYugoslavia TC TD TG TH TJ TL TM TN TO TR TT TV TW TZ UA UG US US_HI UY UZ VC VE VG VI VN VU WS YE ZA ZM ZW ZZ{
	
ipolate `var' year , generate(`var'_ip) epolate	
replace 	`var'=`var'_ip if inrange(year,1939,1949) & `var'==.
replace `var'=. if L.`var'==. & inrange(year,1939,1949)
// ren `var'_ip `var'

}

drop *_ip

foreach var of varlist _all {
	label var `var' ""
}
save "$work_data\temp_FT_UN_IHS.dta",replace


**# Drop
use "$work_data\temp_FT_UN_IHS.dta",clear
*Drop those manually generated
drop IN	BD	PK	MM	ID	PH	TH	VN	LA	KH	CN	TW	JP	KR	KP	IR	DK	GL	MY	SG	TR	SA	BH	IQ	KW	YE	OM	QA	SY	LB	PS	IL	AE JO AT	GR	IE	GB AL BA



*load the manually generally

merge 1:1 year using  "$work_data\FT_UN_IHS.dta"
drop _merge

*Generate North America
/*
BM	Bermuda
CA	Canada
GL	Greenland
PM	Saint Pierre and Miquelon
US	USA
US_HI
CA_NF
*/
br year BM CA GL PM US US_HI CA_NF
*US=US+Hawaii
g US_=.
replace US_=US+US_HI if year<=1938
replace US_=US if year>1938
drop US US_HI
ren US_ US

*CANADA=Canada+Newfoundland
g CA_=.
replace CA_=CA+CA_NF if year<=1938
replace CA_=CA if year>1938
drop CA CA_NF
ren CA_ CA
*tsline CA, xline(1938)

drop PM //PM: 	Saint Pierre and Miquelon not a core country 
// drop EH //EH: Western Sahara
g NorthAmerica=BM +CA +GL +US 
cap drop LATA
g LATA=.
replace LATA=AG+AI+AR+AW+BB+BO+BQ+BR+BS+BZ+CL+CO+CR+CU+CW+DM+DO+EC+GD+GT+GY+HN+HT+JM+KN+KY+LC+MS+MX+NI+PA+PE+PR+PY+SR+SV+SX+TC+TT+UY+VC+VE+VG if year>=1950
replace LATA=AMERICA-NorthAmerica if year<=1938
*tsline LATA, xline(1938 1950)

*very few countries have data for 1939-1949, thus LATA needs to be interpolated
br year AG AI AR AW BB BO BQ BR BS BZ CL CO CR CU CW DM DO EC GD GT GY HN HT JM KN KY LC MS MX NI PA PE PR PY SR SV SX TC TT UY VC VE VG if inrange(year,1937,1951)
br
*linear interpolation for LATA
ipolate LATA year , generate(LATA_ip) epolate	
replace LATA=LATA_ip if inrange(year,1939,1949) & LATA==.
drop LATA_ip 

g other_LATA=LATA-(AR+BR+CL+CO+MX)
gen OD=LATA-(AR+BR+CL+CO+MX) //conventional and new Other LATA


br year CN	HK	JP	KP	KR	MN	MO	TW
g EASA= CN	+HK	+JP	+KP	+KR	+MN	+MO	+TW
g  OB= EASA-( CN+ JP) //conventional Other EASA
g  OB_E= EASA-CN- JP- KR- TW //new Other EASA



br year AF	BD	BN	BT	ID	IN	KH	LA	LK	MM	MV	MY	NP	PH	PK	SG	TH	TL	VN




g NAOC=.
replace NAOC=AU+BM+CA+FJ+FM+GL+KI+MH+NC+NR+NZ+PF+PG+PW+SB+TO+TV+US+VU+WS if year>=1950
replace NAOC=OCEANIA+NorthAmerica if year<=1938
*tsline NAOC, xline(1938 1950)
*very few countries have data for 1939-1949 for Oceania, thus NAOC needs to be interpolated
br year AU BM CA FJ FM GL KI MH NC NR NZ PF PG PW SB TO TV US VU WS NAOC OCEANIA NorthAmerica
*linear interpolation for LATA
ipolate NAOC year , generate(NAOC_ip) epolate	
replace NAOC=NAOC_ip if inrange(year,1939,1949) & NAOC==.
drop NAOC_ip 

*Other NAOC
g OH=NAOC-(US+CA+AU+NZ) //conventional and new Other NAOC


*gen SSEA
gen  SSEA=  AF+  BD+  BN+  BT+  ID+  IN+  KH+  LA+  LK+  MM+  MV+  MY+  NP+  PH+  PK+  SG+  TH+  TL+  VN

*Other SSEA
gen  OI= SSEA-( IN+ ID) //conventional Other SSEA
gen   OI_E= SSEA - BD-IN-ID- MM- PK- PH- TH- VN //new Other SSEA




*tsline DK, xline(1919 1938 1950)

br year AE	BH	IL	IQ	IR	JO	KW	LB	OM	PS	QA	SA	SY	TR	YE

g MENA_ASIA=AE	+BH	+IL	+IQ	+IR	+JO	+KW	+LB	+OM	+PS	+QA	+SA	+SY	+TR	+YE


*tsline MENA_ASIA, xline(1919 1938 1950)
cap drop Central_Asia
g Central_Asia=.
replace Central_Asia=ASIA-MENA_ASIA-EASA-SSEA if year<1950
replace Central_Asia=AM	+AZ	+BY	+GE	+KG	+KZ	+RU	+TJ	+TM	+UA	+UZ if year>=1950
*tsline Central_Asia, xline(1919 1938 1950)

*tsline Central_Asia

br year AE	AF	AM	AZ	BD	BH	BN	BT	BY	CN	GE	HK	ID	IL	IN	IQ	IR	JO	JP	KG	KH	KP	KR	KW	KZ	LA	LB	LK	MM	MN	MO	MV	MY	NP	OM	PH	PK	PS	QA	RU	SA	SG		SY	TH	TJ	TL	TM	TR	TW	UA	UZ	VN	YE


br year DZ	EG	LY	MA	TN


br year AL		BA		BG		CY		CZ		EE		HR		HU		LT		LV		MD		ME		MK		PL		RO		RS		SI		SK 			KS



gen MENA= AE+ BH+ DZ+ EG+ IL+ IQ+ IR+ JO+ KW+ LB+ LY+ MA+ OM+ PS+ QA+ SA+ SY+ TN+ TR+ YE
gen OE=MENA-(TR+EG+DZ)
g OE_E=OE-IR-MA-SA-AE


*Western europe
br year AD	AT	BE	CH		DE	DK	ES	FI		FR	GB	GI	GR	IE	IM	IS	IT	LI	LU	MC	MT	NL	NO	PT	SE	SM	
br year /*AT GR IE IM GB*/ LI SM 


g EURO= AD+ AL+ AT+ BA+ BE+ BG+ CH+ CY+ CZ+ DE+ DK+ EE+ ES+ FI+ FR+ GB+ GG+ GI+ GR+ HR+ HU+ IE+ IM+ IS+ IT+ JE+ KS+ LI+ LT+ LU+ LV+ MC+ MD+ ME+ MK+ MT+ NL+ NO+ PL+ PT+ RO+ RS+ SE+ SI+ SK+ SM

*impute the missing for western europe
*Isel of Mile, grew as Great BRitain
foreach var in   IM {
	cap drop `var'_sh
	cap drop `var'_imputed
	g `var'_sh=`var'/GB

	sum `var'_sh if year==1950
loc `var'_share=r(mean)
drop `var'_sh
g `var'_imputed=``var'_share'*GB
replace `var'=`var'_imputed if `var'==. & year<1950
*tsline `var' `var'_imputed
drop `var'_imputed
	}
	
	
	
*	Liechtenstein, grew as Austria
foreach var in   LI {
	cap drop `var'_sh
	cap drop `var'_imputed
	g `var'_sh=`var'/AT

	sum `var'_sh if year==1950
loc `var'_share=r(mean)
drop `var'_sh
g `var'_imputed=``var'_share'*AT
replace `var'=`var'_imputed if `var'==. & year<1950
*tsline `var' `var'_imputed
drop `var'_imputed
	}
	
*	San Marino, grew as Italy
foreach var in   SM {
	cap drop `var'_sh
	cap drop `var'_imputed
	g `var'_sh=`var'/IT

	sum `var'_sh if year==1950
loc `var'_share=r(mean)
drop `var'_sh
g `var'_imputed=``var'_share'*IT
replace `var'=`var'_imputed if `var'==. & year<1950
*tsline `var' `var'_imputed
drop `var'_imputed
	}	
	
	
g Western_Europe=AD	+AT	+BE	+CH		+DE	+DK	+ES	+FI		+FR	+GB	+GI	+GR	+IE	+IM	+IS	+IT	+LI	+LU	+MC	+MT	+NL	+NO	+PT	+SE	+SM	
*tsline Western_Europe

*Eastern Europe, manually
g Eastern_Europe=EUROPE-Western

gen QM=AL		+BA		+BG		+CY		+CZ		+EE		+HR		+HU		+LT		+LV		+MD		+ME		+MK		+PL		+RO		+RS		+SI		+SK +			KS if year>=1950
*tsline Eastern_Europe QM
drop Eastern_Europe QM

br year /*AL		 BA		 BG		 CY		 CZ		 EE		 HR		 HU	*/	 LT		 LV		 MD		 ME  MK		 PL		 RO		 RS		 SI		 SK  			KS

*we include Bosnia in the estimate for Austria-Hungary from 1878 to 1918 and in the series for Yugoslavia thereafter

*	Bosnia, grew as Austria-Hungary during 1878-1918
*	Bosnia, grew as Yugoslavia during 1918-1950
g Yugos=HR+SI+RS+MK+BA+ME
*tsline SerbiaYugoslavia Yugos

	
*BUlgaria as a hsare of Albania (proxy of smootheth Ottoman empire)
g crec=AL/L.AL-1
cap drop BG_imp
g BG_imp=.

	replace BG_imp=(F.BG/(1+F.crec))	if year==1878

forv var =  1877(-1)1800{
replace BG_imp=(F.BG_imp/(1+F.crec))	if year==`var'	
}
*tsline BG_imp BG
replace BG=BG_imp if BG==.
drop BG_imp crec
	
	
*Cyprus grows like greece	
br year CY GR	
g crec=GR/L.GR-1
cap drop CY_imp
g CY_imp=.

	replace CY_imp=(F.CY/(1+F.crec))	if year==1878

forv var =  1877(-1)1800{
replace CY_imp=(F.CY_imp/(1+F.crec))	if year==`var'	
}
*tsline CY_imp CY
replace CY=CY_imp if CY==.
drop CY_imp crec



*Czech Republic grows like Czechoslovakia during 1919-1949 and like Austria-Hungary between 1800-1918
br year CZ CS AustriaHungary
g crec=CS/L.CS-1
cap drop CZ_imp
g CZ_imp=.

	replace CZ_imp=(F.CZ/(1+crec))	if year==1949

forv var =  1948(-1)1919{
replace CZ_imp=(F.CZ_imp/(1+F.crec))	if year==`var'	
}
*tsline CZ_imp CZ
replace CZ=CZ_imp if CZ==.
drop CZ_imp crec

g crec=AustriaHungary/L.AustriaHungary-1
cap drop CZ_imp
g CZ_imp=.

	replace CZ_imp=(F.CZ/(1+crec))	if year==1918

forv var =  1917(-1)1800{
replace CZ_imp=(F.CZ_imp/(1+F.crec))	if year==`var'	
}
*tsline CZ_imp CZ
replace CZ=CZ_imp if CZ==.
drop CZ_imp crec
*tsline CZ


*Estonia grows like the Russian Empire	
br year EE RU	RussiaEmpireUSSR
g crec=RussiaEmpireUSSR/L.RussiaEmpireUSSR-1
cap drop EE_imp
g EE_imp=.

	replace EE_imp=(F.EE/F.RussiaEmpireUSSR)*F.RussiaEmpireUSSR	if year==1918

forv var =  1917(-1)1800{
replace EE_imp=(F.EE_imp/(1+F.crec))	if year==`var'	
}
*tsline EE_imp EE
replace EE=EE_imp if EE==.
drop EE_imp crec
*tsline EE



*Croatia grows like t  Austria(1830-1919), AustriaHungary (1800-1829), and SerbiaYugoslavia(1920-1949)
br year HR	SerbiaYugoslavia Yugos AustriaHungary AT
g crec=SerbiaYugoslavia/L.SerbiaYugoslavia-1
cap drop HR_imp
g HR_imp=.

	replace HR_imp=(F.HR/(1+crec))	if year==1949

forv var =  1948(-1)1919{
replace HR_imp=(F.HR_imp/(1+F.crec))	if year==`var'	
}
*tsline HR_imp HR
replace HR=HR_imp if HR==.
drop HR_imp crec

	g crec_AT=AT/L.AT-1
	cap drop HR_imp_
	g HR_imp_=.
		replace HR_imp_=(F.HR/(1+crec_))	if year==1918
	forv var =  1917(-1)1830{
	replace HR_imp_=(F.HR_imp_/(1+F.crec_AT))	if year==`var'	
	}
	*tsline HR_imp_ HR_imp HR
	replace HR=HR_imp if HR==.
	drop HR_imp crec

	g crec=AustriaHungary/L.AustriaHungary-1
	cap drop HR_imp
	g HR_imp=.
		replace HR_imp=(F.HR/(1+crec))	if year==1829
	forv var =  1828(-1)1800{
	replace HR_imp=(F.HR_imp/(1+F.crec))	if year==`var'	
	}
	*tsline HR_imp HR
	replace HR=HR_imp if HR==.
	*tsline HR HR_imp 
	drop HR_imp crec



*Hungary grows like AustriaHungary (1800-1918)
br year HU	AustriaHungary 
g HU_imp=.
replace HU_imp=F.HU/AustriaHungary if year==1918
replace HU=HU_imp*AustriaHungary if year==1918 & HU==.
replace HU_imp=HU if year==1918 
g crec=AustriaHungary/L.AustriaHungary-1
// drop HU_imp
// g HU_imp=.
	forv var =  1917(-1)1800{
	replace HU_imp=(F.HU_imp/(1+F.crec))	if year==`var'	
	}
	replace HU=HU_imp if HU==.	
	*tsline HU HU_imp
	drop HU_imp crec
	

	
	


foreach x in LT LV {
	
*	Lithuania/Latvia grows like the Russian Empire	
br year `x' RU	RussiaEmpireUSSR
g crec=RussiaEmpireUSSR/L.RussiaEmpireUSSR-1
cap drop `x'_imp
g `x'_imp=.

	replace `x'_imp=(F.`x'/F.RussiaEmpireUSSR)*F.RussiaEmpireUSSR	if year==1918

forv var =  1917(-1)1800{
replace `x'_imp=(F.`x'_imp/(1+F.crec))	if year==`var'	
}
*tsline `x'_imp `x'
replace `x'=`x'_imp if `x'==.
drop `x'_imp crec
*tsline `x'
}








*	Moldova grows like the Russian Empire	
br year MD RU	RussiaEmpireUSSR
g crec=RussiaEmpireUSSR/L.RussiaEmpireUSSR-1
cap drop MD_imp
g MD_imp=.
	replace MD_imp=(F.MD/RussiaEmpireUSSR)*RussiaEmpireUSSR	if year==1949

forv var =  1948(-1)1800{
replace MD_imp=(F.MD_imp/(1+F.crec))	if year==`var'	
}
*tsline MD_imp MD
replace MD=MD_imp if MD==.
drop MD_imp crec
*tsline MD



*North Macedonia/Serbia/Kosovo/Slovenia/Slovakia grows like t  Austria(1830-1919), AustriaHungary (1800-1829), and SerbiaYugoslavia(1920-1949)
foreach x in MK RS SI		 SK  			KS{
br year `x'	SerbiaYugoslavia Yugos AustriaHungary AT
g crec=SerbiaYugoslavia/L.SerbiaYugoslavia-1
cap drop `x'_imp
g `x'_imp=.

	replace `x'_imp=(F.`x'/(1+crec))	if year==1949

forv var =  1948(-1)1919{
replace `x'_imp=(F.`x'_imp/(1+F.crec))	if year==`var'	
}
*tsline `x'_imp `x'
replace `x'=`x'_imp if `x'==.
drop `x'_imp crec

	g crec_AT=AT/L.AT-1
	cap drop `x'_imp_
	g `x'_imp_=.
		replace `x'_imp_=(F.`x'/(1+crec_))	if year==1918
	forv var =  1917(-1)1830{
	replace `x'_imp_=(F.`x'_imp_/(1+F.crec_AT))	if year==`var'	
	}
	*tsline `x'_imp_ `x'_imp `x'
	replace `x'=`x'_imp if `x'==.
	drop `x'_imp crec

	g crec=AustriaHungary/L.AustriaHungary-1
	cap drop `x'_imp
	g `x'_imp=.
		replace `x'_imp=(F.`x'/(1+crec))	if year==1829
	forv var =  1828(-1)1800{
	replace `x'_imp=(F.`x'_imp/(1+F.crec))	if year==`var'	
	}
	*tsline `x'_imp `x'
	replace `x'=`x'_imp if `x'==.
	*tsline `x' `x'_imp 
	drop `x'_imp crec
}



*Montenegro grows like  Montenegro(1800-1878), AustriaHungary (1800-1829), and SerbiaYugoslavia(1920-1949)
tsline ME
br year ME	SR
*tsline ME
g crec=ME/L.ME-1
cap drop ME_imp
g ME_imp=.
replace ME_imp=(F.ME)	if year==1878	
forv var =  1877(-1)1800{
replace ME_imp=(F.ME_imp/(1+F.crec))	if year==`var'	
}
tsline ME ME_imp
replace ME=ME_imp if inrange(year,1800,1878)
drop ME_imp crec

replace ME=. if inrange(year, 1913,1918)
ipolate ME year , generate(ME_ip) epolate	
replace ME=ME_ip if ME==.
drop ME_ip
*tsline ME 




foreach x in PL {
	
*	 grows like the Russian Empire	
br year `x' RU	RussiaEmpireUSSR

g crec=RussiaEmpireUSSR/L.RussiaEmpireUSSR-1
cap drop `x'_imp
g `x'_imp=.

	replace `x'_imp=(F.`x'/F.RussiaEmpireUSSR)*F.RussiaEmpireUSSR	if year==1918

forv var =  1917(-1)1800{
replace `x'_imp=(F.`x'_imp/(1+F.crec))	if year==`var'	
}
*tsline `x'_imp `x'
replace `x'=`x'_imp if `x'==.
drop `x'_imp crec
*tsline `x'
}




*	Romania grows like Romania in (1859-1919) and AustriaHungary (1800-1858)
br year RO AustriaHungary
*tsline RO
g crec=RO/L.RO-1
cap drop RO_imp
g RO_imp=.
replace RO_imp=(F.RO)	if year==1918	
forv var =  1917(-1)1800{
replace RO_imp=(F.RO_imp/(1+F.crec))	if year==`var'	
}
*tsline RO
replace RO=RO_imp if inrange(year,1859,1918)
drop RO_imp crec
*tsline RO

	g crec=AustriaHungary/L.AustriaHungary-1
	cap drop RO_imp
	g RO_imp=.
		replace RO_imp=(F.RO/(1+crec))	if year==1858
	forv var =  1857(-1)1800{
	replace RO_imp=(F.RO_imp/(1+F.crec))	if year==`var'	
	}
	*tsline RO_imp RO
	replace RO=RO_imp if RO==.
	*tsline RO RO_imp 
	drop RO_imp crec






	gen QM=AL		+BA		+BG		+CY		+CZ		+EE		+HR		+HU		+LT		+LV		+MD		+ME		+MK		+PL		+RO		+RS		+SI		+SK +			KS
	
	br year QM AL		BA		BG		CY		CZ		EE		HR		HU		LT		LV		MD		ME		MK		PL		RO		RS		SI		SK 			KS
	
	*tsline QM Western_Europe
	

	
	g EURO_=QM+Western_Europe
	*tsline EURO_	
	br year EURO_ EURO EUROPE
	drop EURO
	ren EURO_ EURO

	
*Other Western Europe
gen  OC= EURO-( DE+ FR+ GB+ IT+ ES+ SE+ QM)
g  OC_E= OC- NL- NO- DK






*tsline ZA
*French West Africa=Mauritania+Senegal+French Sudan (now Mali)+French Guinea (now Guinea)+Ivory Coast+Upper Volta (now Burkina Faso)+Dahomey (now Benin)+Niger.

*Cote divoire/Mali grows like AFRICA (1939,1949) and like FrenchWestAfrica (1800-1938)
foreach x in CI ML NE{
	

br year `x'	 FrenchWestAfrica AFRICA
g crec_AF=AFRICA/L.AFRICA-1
g imputed=L.FrenchWestAfrica*(1+crec_AF)
replace imputed=L.imputed*(1+crec_AF) if imputed==.
replace FrenchWestAfrica=imputed if inrange(year,1939,1949) & FrenchWestAfrica==.
drop crec_AF imputed 

sum FrenchWestAfrica if year==1949
g FWA=r(mean)
 
sum `x'	 if year==1950
g m`x'	=r(mean)
g sh=m`x'	/FWA
replace m`x'	=. if year!=1949
drop FWA sh
g crec_FWA=FrenchWestAfrica/L.FrenchWestAfrica-1
g imputed=F.m`x'	/(1+F.crec_FWA)

	forv var =  1947(-1)1800{
	replace imputed=F.imputed/(1+F.crec_FWA)	if year==`var'	
	}
replace `x'	=m`x'	 if `x'	==.
replace `x'	=imputed if `x'	==.
*tsline `x'	
drop m`x'	 crec_FWA imputed	
}

tsline CI ML NE



*Kenya grows like AFRICA (1939,1949) and like BritishEastAfrica (1800-1938)
br year KE	 BritishEastAfrica AFRICA
g crec_AF=AFRICA/L.AFRICA-1
g imputed=L.BritishEastAfrica*(1+crec_AF)
replace imputed=L.imputed*(1+crec_AF) if imputed==.
replace BritishEastAfrica=imputed if inrange(year,1939,1949) & BritishEastAfrica==.
drop crec_AF imputed 

sum BritishEastAfrica if year==1949
g BEA=r(mean)
 
sum KE	 if year==1950
g mKE	=r(mean)
g sh=mKE	/BEA
replace mKE	=. if year!=1949
drop BEA sh
g crec_FWA=BritishEastAfrica/L.BritishEastAfrica-1
g imputed=F.mKE	/(1+F.crec_FWA)

	forv var =  1947(-1)1800{
	replace imputed=F.imputed/(1+F.crec_FWA)	if year==`var'	
	}
replace KE	=mKE	 if KE	==.
replace KE	=imputed if KE	==.
*tsline KE	
drop mKE	 crec_FWA imputed


*Uganda grows liUG AFRICA (1939,1949) and liUG BritishEastAfrica (1800-1938)
br year UG	 BritishEastAfrica AFRICA
g crec_AF=AFRICA/L.AFRICA-1
g imputed=L.BritishEastAfrica*(1+crec_AF)
replace imputed=L.imputed*(1+crec_AF) if imputed==.
replace BritishEastAfrica=imputed if inrange(year,1939,1949) & BritishEastAfrica==.
drop crec_AF imputed 

sum BritishEastAfrica if year==1949
g BEA=r(mean)
 
sum UG	 if year==1950
g mUG	=r(mean)
g sh=mUG	/BEA
replace mUG	=. if year!=1949
drop BEA sh
g crec_FWA=BritishEastAfrica/L.BritishEastAfrica-1
g imputed=F.mUG	/(1+F.crec_FWA)

	forv var =  1947(-1)1800{
	replace imputed=F.imputed/(1+F.crec_FWA)	if year==`var'	
	}
replace UG	=mUG	 if UG	==.
replace UG	=imputed if UG	==.
*tsline UG	
drop mUG	 crec_FWA imputed	



*Rwanda grows like AFRICA (1939,1949) and like RwandaandBurundi (1800-1938)
br year RW	 RwandaandBurundi AFRICA
g crec_AF=AFRICA/L.AFRICA-1
g imputed=L.RwandaandBurundi*(1+crec_AF)
replace imputed=L.imputed*(1+crec_AF) if imputed==.
replace RwandaandBurundi=imputed if inrange(year,1939,1949) & RwandaandBurundi==.
drop crec_AF imputed 

sum RwandaandBurundi if year==1949
g RAB=r(mean)
 
sum RW	 if year==1950
g mKE	=r(mean)
g sh=mKE	/RAB
replace mKE	=. if year!=1949
drop RAB sh
g crec_FWA=RwandaandBurundi/L.RwandaandBurundi-1
g imputed=F.mKE	/(1+F.crec_FWA)

	forv var =  1947(-1)1800{
	replace imputed=F.imputed/(1+F.crec_FWA)	if year==`var'	
	}
replace RW	=mKE	 if RW	==.
replace RW	=imputed if RW	==.
*tsline RW	
drop mKE	 crec_FWA imputed	


*tsline CI ML NE KE RW



*Sudan grows like AFRICA (1939,1949) and like SudanAngloEgyptianSudan (1800-1938)
br year SD	 SudanAngloEgyptianSudan AFRICA
g crec_AF=AFRICA/L.AFRICA-1
g imputed=L.SudanAngloEgyptianSudan*(1+crec_AF)
replace imputed=L.imputed*(1+crec_AF) if imputed==.
replace SudanAngloEgyptianSudan=imputed if inrange(year,1939,1949) & SudanAngloEgyptianSudan==.
drop crec_AF imputed 

sum SudanAngloEgyptianSudan if year==1949
g RAB=r(mean)
 
sum SD	 if year==1950
g mKE	=r(mean)
g sh=mKE	/RAB
replace mKE	=. if year!=1949
drop RAB sh
g crec_FWA=SudanAngloEgyptianSudan/L.SudanAngloEgyptianSudan-1
g imputed=F.mKE	/(1+F.crec_FWA)

	forv var =  1947(-1)1800{
	replace imputed=F.imputed/(1+F.crec_FWA)	if year==`var'	
	}
replace SD	=mKE	 if SD	==.
replace SD	=imputed if SD	==.
*tsline SD	
drop mKE	 crec_FWA imputed	


*tsline CD ET KE CI ML NE NG RW SD ZA


br year	CD ET KE CI ML NE NG RW SD ZA


g North_Africa=DZ	+EG	+	LY	+MA	+TN
g SSAF_=AFRICA-North_Africa




gen SSAF= AO+ BF+ BI+ BJ+ BW+ CD+ CF+ CG+ CI+ CM+ CV+ DJ+ ER+ ET+ GA+ GH+ GM+ GN+ GQ+ GW+ KE+ KM+ LR+ LS+ MG+ ML+ MR+ MU+ MW+ MZ+ NA+ NE+ NG+ RW+ SC+ SD+ SL+ SN+ SO+ SS+ ST+ SZ+ TD+ TG+ TZ+ UG+ ZA+ ZM+ ZW

gen OJ=SSAF-ZA

g OJ_E=OJ-CD-ET-KE-CI-ML-NE-NG-RW-SD	

br year North_Africa SSAF_ SSAF OJ OJ_E

*tsline SSAF_ SSAF North_Africa
*tsline North_Africa

*In SSAF, There are 16 million people of difference between 1949 and 1950 (a lot). So I assume that SSAF grows as FT show for 1800-1949 but they match perfectly between 1949 and 1950 (match perfectly with UN data)
g crec_SSAF=SSAF_/L.SSAF_-1
g imputed=F.SSAF if year==1949
	forv var =  1948(-1)1800{
	replace imputed=F.imputed/(1+F.crec_SSAF)	if year==`var'	
	}
replace SSAF=imputed if SSAF==. & year<1950	
drop crec_SSAF imputed SSAF_ OJ OJ_E

gen OJ=SSAF-ZA

g OJ_E=OJ-CD-ET-KE-CI-ML-NE-NG-RW-SD	

*tsline OJ_E




*Russia/Ukraine/Belarus/Armenia/Azerbaijan/Georgia/Kyrgyzstan/Kazakhstan/Tajikistan/Turkmenistan grow as the Russian Emprie 1800-1949
br RU  UA BY AM AZ GE KG KZ TJ UZ
tsline UZ
foreach x in RU  UA BY AM AZ GE KG KZ TJ TM{
	
	g crec_RussiaEmpireUSSR=RussiaEmpireUSSR/L.RussiaEmpireUSSR-1
	g imputed=F.`x' if year==1949
		forv var =  1948(-1)1800{
		replace imputed=F.imputed/(1+F.crec_RussiaEmpireUSSR)	if year==`var'	
		}
	replace `x'=imputed if `x'==. & year<1950	
	drop crec_RussiaEmpireUSSR imputed 
	
}

*tsline RU  UA BY AM AZ GE KG KZ TJ

*Uzbekistan

br year UZ
g UZ_=UZ if year<1869
g crec_UZ_=UZ_/L.UZ_-1
sum crec_UZ_ if year==1867
replace crec_UZ_=r(mean) if year==1868 | year==1869
g imputed=UZ if year==1869
		forv var =  1868(-1)1800{
		replace imputed=F.imputed/(1+F.crec_UZ_)	if year==`var'	
		}
	replace UZ=imputed if year<1869	
drop imputed crec_UZ_	
drop UZ_

ipolate UZ year , generate(UZ_ip) epolate	
replace 	UZ=UZ_ip if inrange(year,1921,1949) & UZ==.
drop UZ_ip



	br AM   AZ   BY   GE   KG   KZ   RU   TJ   TM   UA   UZ
tsline RU  UA BY AM AZ GE KG KZ TJ UZ

*RUCA

g World_=AMERICA+AFRICA+EUROPE+ASIA+OCEANIA
gen  RUCA=  AM+  AZ+  BY+  GE+  KG+  KZ+  RU+  TJ+  TM+  UA+  UZ
g World=MENA +SSEA +EASA +NAOC +LATA +EURO +SSAF+RUCA
g World_sRUCA=MENA +SSEA +EASA +NAOC +LATA +EURO +SSAF if year<1950
g RUCA_=(AMERICA+AFRICA+EUROPE+ASIA+OCEANIA)-(AMERICA+OCEANIA)-EURO-EASA-SSEA-MENA-SSAF
gen OA=RUCA-RU
br year World_ RUCA World World_ RussiaEmpireUSSR RU World_sRUCA RUCA_
br year RUCA_ World_
tsline  World_ World
tsline RUCA_ RUCA RU OA

tsline World_ World World_sRUCA RussiaEmpireUSSR


drop Yugos Western_Europe EUROPE OCEANIA ASIA AFRICA AMERICA World World_ World_sRUCA BritishEastAfrica FrenchWestAfrica 
drop other_LATA AustriaHungary North_Africa RUCA_ OttomanBalkans RussiaEmpireUSSR RwandaandBurundi SerbiaYugoslavia SudanAngloEgyptianSudan NorthAmerica MENA_ASIA Central_Asia


foreach var of varlist _all {
	label var `var' ""
}
save "$work_data\temp_extended_countries.dta",replace





**# Graphical checks

*Regions	
foreach country in MENA SSEA EASA NAOC LATA EURO SSAF {	
	tsline  `country', xline( 1938 1950) title(`country') xline(1919,lcolor(gray))
	graph export "$root\outputs\graphs population 1800-2023\\`country'.png",replace
	
}

*Eastern Europe
foreach country in  QM AL		BA		BG		CY		CZ		EE		HR		HU		LT		LV		MD		ME		MK		PL		RO		RS		SI		SK 			KS {
	
	tsline  `country', xline( 1938 1950) title(`country') xline(1919,lcolor(gray))
	graph export "$root\outputs\graphs population 1800-2023\\`country'.png",replace
	
}	


*Western Europe
foreach country in  AD	 AT	 BE	 CH		 DE	 DK	 ES	 FI		 FR	 GB	 GI	 GR	 IE	 IM	 IS	 IT	 LI	 LU	 MC	 MT	 NL	 NO	 PT	 SE	 SM	 {
	
	tsline  `country', xline( 1938 1950) title(`country') xline(1919,lcolor(gray))
	graph export "$root\outputs\graphs population 1800-2023\\`country'.png",replace
	
}	


*EASA
foreach country in  CN	 HK	 JP	 KP	 KR	 MN	 MO	 TW OB OB_E{
	
	tsline  `country', xline( 1938 1950) title(`country') xline(1919,lcolor(gray))
	graph export "$root\outputs\graphs population 1800-2023\\`country'.png",replace
	
}	

*LATA
foreach country in  AR BR CL CO MX OD{
	
	tsline  `country', xline( 1938 1950) title(`country') xline(1919,lcolor(gray))
	graph export "$root\outputs\graphs population 1800-2023\\`country'.png",replace
	
}	

*NAOC
foreach country in  OH US CA AU NZ{
	
	tsline  `country', xline( 1938 1950) title(`country') xline(1919,lcolor(gray))
	graph export "$root\outputs\graphs population 1800-2023\\`country'.png",replace
	
}	


*SSEA
foreach country in  AF   BD   BN   BT   ID   IN   KH   LA   LK   MM   MV   MY   NP   PH   PK   SG   TH   TL   VN OI OI_E{
	
	tsline  `country', xline( 1938 1950) title(`country') xline(1919,lcolor(gray))
	graph export "$root\outputs\graphs population 1800-2023\\`country'.png",replace
	
}


*MENA
foreach country in  AE  BH  DZ  EG  IL  IQ  IR  JO  KW  LB  LY  MA  OM  PS  QA  SA  SY  TN  TR  YE OE OE_E{
	
	tsline  `country', xline( 1938 1950) title(`country') xline(1919,lcolor(gray))
	graph export "$root\outputs\graphs population 1800-2023\\`country'.png",replace
	
}

*SSAF
foreach country in  OJ_E OJ CD ET KE CI ML NE NG RW SD ZA{
	
	tsline  `country', xline( 1938 1950) title(`country') xline(1919,lcolor(gray))
	graph export "$root\outputs\graphs population 1800-2023\\`country'.png",replace
	
}


*RUCA
foreach country in AM   AZ   BY   GE   KG   KZ   RU   TJ   TM   UA   UZ OA{
	
	tsline  `country', xline( 1938 1950) title(`country') xline(1919,lcolor(gray))
	graph export "$root\outputs\graphs population 1800-2023\\`country'.png",replace
	
}



**# Final dataset  1800-2100 57extendedterritories


use "$work_data\temp_extended_countries.dta",clear

drop LATA SSAF EASA SSEA NAOC EURO MENA RUCA
g LATA=OD+(AR+BR+CL+CO+MX)
g SSAF=CD+ET+KE+CI+ML+NE+NG+RW+SD +OJ_E+ZA
g EASA= CN+ JP+ KR+ TW  +OB_E
g SSEA=BD+IN+ID+ MM+ PK+ PH+ TH+ VN+OI_E
g NAOC=(US+CA+AU+NZ)+ OH
g EURO=DE+FR+GB+IT+ES+SE+NL+NO+DK+OC_E+QM
g MENA=(TR+EG+DZ)+IR+MA+SA+AE+OE_E
g RUCA=OA+RU



gen  WO= EURO+ NAOC+ LATA+ MENA+ SSAF+ RUCA+ EASA+ SSEA

ren * pop999i*
ren pop999iyear year
reshape long pop999i , i(year) j(country) string	



g region=country
	replace region="Germany" if region=="DE"
	replace region="France" if region=="FR"
	replace region="United Kingdom" if region=="GB"
	replace region="Italy" if region=="IT"
	replace region="Spain" if region=="ES"
	replace region="Sweden" if region=="SE"
		replace region="Netherlands" if region=="NL"
		replace region="Norway" if region=="NO"
		replace region="Denmark" if region=="DK"
	replace region="Other Western Europe" if region=="OC_E"
	replace region="Eastern Europe" if region=="QM"
	replace region="USA" if region=="US"
	replace region="Canada" if region=="CA"
	replace region="Australia" if region=="AU"
	replace region="New Zealand" if region=="NZ"
	replace region="Other NAOC" if region=="OH"
	replace region="Argentina" if region=="AR"
	replace region="Brazil" if region=="BR"
	replace region="Chile" if region=="CL"
	replace region="Colombia" if region=="CO"
	replace region="Mexico" if region=="MX"
	replace region="Other Latin America" if region=="OD"
	replace region="Turkey" if region=="TR"
	replace region="Egypt" if region=="EG"
	replace region="Algeria" if region=="DZ"
		replace region="Iran" if region=="IR"
		replace region="Morocco" if region=="MA"
		replace region="Saudi Arabia" if region=="SA"
		replace region="United Arab Emirates" if region=="AE"		
	replace region="Other MENA" if region=="OE_E"
	replace region="South Africa" if region=="ZA"
		replace region="DR Congo" if region=="CD"	
		replace region="Ethiopia" if region=="ET"	
		replace region="Kenya" if region=="KE"	
		replace region="Ivory Coast" if region=="CI"	
		replace region="Mali" if region=="ML"	
		replace region="Niger" if region=="NE"	
		replace region="Nigeria" if region=="NG"	
		replace region="Rwanda" if region=="RW"	
		replace region="Sudan" if region=="SD"			
	replace region="Other SSAF" if region=="OJ_E"
	replace region="Russian Federation" if region=="RU"
	replace region="Other RUCA" if region=="OA"
	replace region="China" if region=="CN"
	replace region="Japan" if region=="JP"
		replace region="South Korea" if region=="KR"
		replace region="Taiwan" if region=="TW"	
	replace region="Other East Asia" if region=="OB_E"
	replace region="India" if region=="IN"
	replace region="Indonesia" if region=="ID"
		replace region="Bangladesh" if region=="BD"
		replace region="Myanmar" if region=="MM"	
		replace region="Pakistan" if region=="PK"
		replace region="Philipinnes" if region=="PH"
		replace region="Thailand" if region=="TH"
		replace region="Vietnam" if region=="VN"	
	replace region="Other SSEA" if region=="OI_E"
	replace region="World " if 						region=="WO"
ren region countryname	


save "$work_data\pop_1800_2023_57extendedterritories.dta",replace


use "$work_data\pop_1800_2100_57extendedterritories.dta",clear
drop if year<2024
append using "$work_data\pop_1800_2023_57extendedterritories.dta"

drop countryname

g region=country
	replace region="Germany" if region=="DE"
	replace region="France" if region=="FR"
	replace region="United Kingdom" if region=="GB"
	replace region="Italy" if region=="IT"
	replace region="Spain" if region=="ES"
	replace region="Sweden" if region=="SE"
		replace region="Netherlands" if region=="NL"
		replace region="Norway" if region=="NO"
		replace region="Denmark" if region=="DK"
	replace region="Other Western Europe" if region=="OC_E"
	replace region="Eastern Europe" if region=="QM"
	replace region="USA" if region=="US"
	replace region="Canada" if region=="CA"
	replace region="Australia" if region=="AU"
	replace region="New Zealand" if region=="NZ"
	replace region="Other NAOC" if region=="OH"
	replace region="Argentina" if region=="AR"
	replace region="Brazil" if region=="BR"
	replace region="Chile" if region=="CL"
	replace region="Colombia" if region=="CO"
	replace region="Mexico" if region=="MX"
	replace region="Other Latin America" if region=="OD"
	replace region="Turkey" if region=="TR"
	replace region="Egypt" if region=="EG"
	replace region="Algeria" if region=="DZ"
		replace region="Iran" if region=="IR"
		replace region="Morocco" if region=="MA"
		replace region="Saudi Arabia" if region=="SA"
		replace region="United Arab Emirates" if region=="AE"		
	replace region="Other MENA" if region=="OE_E"
	replace region="South Africa" if region=="ZA"
		replace region="DR Congo" if region=="CD"	
		replace region="Ethiopia" if region=="ET"	
		replace region="Kenya" if region=="KE"	
		replace region="Ivory Coast" if region=="CI"	
		replace region="Mali" if region=="ML"	
		replace region="Niger" if region=="NE"	
		replace region="Nigeria" if region=="NG"	
		replace region="Rwanda" if region=="RW"	
		replace region="Sudan" if region=="SD"			
	replace region="Other SSAF" if region=="OJ_E"
	replace region="Russian Federation" if region=="RU"
	replace region="Other RUCA" if region=="OA"
	replace region="China" if region=="CN"
	replace region="Japan" if region=="JP"
		replace region="South Korea" if region=="KR"
		replace region="Taiwan" if region=="TW"	
	replace region="Other East Asia" if region=="OB_E"
	replace region="India" if region=="IN"
	replace region="Indonesia" if region=="ID"
		replace region="Bangladesh" if region=="BD"
		replace region="Myanmar" if region=="MM"	
		replace region="Pakistan" if region=="PK"
		replace region="Philipinnes" if region=="PH"
		replace region="Thailand" if region=="TH"
		replace region="Vietnam" if region=="VN"	
	replace region="Other SSEA" if region=="OI_E"
	replace region="World " if 						region=="WO"
ren region countryname	



save "$work_data\pop_1800_2100_57extendedterritories.dta",replace






**# Final dataset  1800-2100 33coreterritories

*1800_2023_33coreterritories poptot
use  "$work_data\pop_1800_2100_33coreterritories.dta",clear
 *Keep core countries
gen corecountry=.
foreach c of global coreterritories {
	replace corecountry=1 if country=="`c'"
	}
	keep if corecountry==1
drop if year<2024
keep year country pop999i
tab year
save "$work_data\pop_1800_2023_33coreterritories.dta",replace


*1800_2023_33coreterritories pop shares
use  "$work_data\pop_1800_2100_33coreterritories.dta",clear
 *Keep core countries
gen corecountry=.
foreach c of global coreterritories {
	replace corecountry=1 if country=="`c'"
	}
	keep if corecountry==1 | inlist(country,"ESAF","WCAF", "SEAS", "SAS")
foreach var in pop992i pop0_14i pop65i pop999f pop0_14f pop65f pop15_64i pop15_64f pop991i{
	replace `var'=`var'/pop999i
}	
keep year country pop992i pop0_14i pop65i pop999f pop0_14f pop65f pop15_64i pop15_64f pop991i
save "$work_data\pop_1800_2100_33coreterritories_shares.dta",replace
	
	
use  "$work_data\pop_1800_2100_33coreterritories.dta",clear	
keep if inlist(country,"ESAF","WCAF", "SEAS", "SAS" ,"SSAF","SSEA")
keep year country pop999i
reshape wide pop999i, i(year) j(country) string
replace pop999iESAF=pop999iESAF/pop999iSSAF
replace pop999iWCAF=pop999iWCAF/pop999iSSAF
replace pop999iSAS=pop999iSAS/pop999iSSEA
replace pop999iSEAS=pop999iSEAS/pop999iSSEA
drop pop999iSSAF pop999iSSEA
save "$work_data\pop_1800_2100_sharesSSEA_SSAF.dta",replace
// reshape long pop999i, i(year) j(country) string
	
	
*Final dataset	
use "$work_data\pop_1800_2100_57extendedterritories.dta",clear
drop if year>2023
 *Keep core countries
gen corecountry=.
foreach c of global coreterritories {
	replace corecountry=1 if country=="`c'"
	}
	keep if corecountry==1
drop countryname corecountry	
append using "$work_data\pop_1800_2023_33coreterritories.dta"	
reshape wide pop999i, i(year) j(country) string
merge 1:1 year using "$work_data\pop_1800_2100_sharesSSEA_SSAF.dta"
drop _merge
gen pop999iSSAF=pop999iZA+pop999iOJ
gen pop999iSSEA=pop999iIN+pop999iID+pop999iOI
replace pop999iESAF=pop999iESAF*pop999iSSAF
replace pop999iWCAF=pop999iWCAF*pop999iSSAF
replace pop999iSAS=pop999iSAS*pop999iSSEA
replace pop999iSEAS=pop999iSEAS*pop999iSSEA
drop pop999iSSAF pop999iSSEA
reshape long pop999i, i(year) j(country) string

merge 1:1 year country using "$work_data\pop_1800_2100_33coreterritories_shares.dta"
foreach var in pop992i pop0_14i pop65i pop999f pop0_14f pop65f pop15_64i pop15_64f pop991i{
	replace `var'=`var'*pop999i
}	
drop _merge
save "$outputs\pop_1800_2100_33coreterritories.dta",replace



